import { TSModule } from './file-utils';
import { TSPOptions } from './system';
export declare const SRC_FILES: string[];
export declare const BACKUP_DIRNAME = "lib-backup";
export declare const RESOURCES_PATH: string;
export declare const defaultInstallLibraries: string[];
/**
 * Parse file, array of files, or glob of files and get TSModule info for each
 */
export declare function parseFiles(fileOrFilesOrGlob: string | string[], libDir: string, includeSrc?: boolean): TSModule[] & {
    patched: TSModule[];
    unPatchable: TSModule[];
    canUpdateOrPatch: TSModule[];
    patchable: TSModule[];
};
/**
 * Set app options (superimposes opts onto defaultOptions)
 */
export declare const setOptions: (opts?: Partial<TSPOptions>) => TSPOptions;
/**
 * Patch TypeScript modules
 */
export declare function install(opts?: Partial<TSPOptions>): boolean;
/**
 * Remove patches from TypeScript modules
 */
export declare function uninstall(opts?: Partial<TSPOptions>): boolean;
/**
 * Check if files can be patched
 */
export declare function check(fileOrFilesOrGlob?: string | string[], opts?: Partial<TSPOptions>): TSModule[] & {
    patched: TSModule[];
    unPatchable: TSModule[];
    canUpdateOrPatch: TSModule[];
    patchable: TSModule[];
};
/**
 * Patch a TypeScript module
 */
export declare function patch(fileOrFilesOrGlob: string | string[], opts?: Partial<TSPOptions>): boolean;
export declare function unpatch(fileOrFilesOrGlob: string | string[], opts?: Partial<TSPOptions>): boolean;
