/**
 * Attempts to locate global installation of TypeScript
 */
export declare const getGlobalTSDir: () => any;
/**
 * Get absolute path for module file
 */
export declare const getModuleAbsolutePath: (filename: string, libDir: string) => string;
export declare const mkdirIfNotExist: (dir: string) => string | false | undefined;
export interface TSPackage {
    version: string;
    packageFile: string;
    packageDir: string;
    config: TSPConfig;
    libDir: string;
}
/**
 * Get TypeScript package info - Resolve from dir, throws if not cannot find TS package
 */
export declare function getTSPackage(dir?: string): TSPackage;
export interface TSModule {
    filename: string;
    file: string;
    dir: string;
    canPatch: boolean;
    patchVersion: string | false | null;
    moduleSrc?: string;
    outOfDate: boolean;
}
/**
 * Get TypeScript module info
 */
export declare function getTSModule(file: string, includeSrc?: boolean): TSModule;
export interface TSPConfig {
    readonly file: string;
    readonly version: string;
    modules: {
        [x: string]: number;
    };
    save: Function;
}
