export declare type TSPOptions = typeof defaultOptions & {
    /** @deprecated Use 'dir' */
    basedir?: string;
};
export declare const defaultOptions: {
    logLevel: number;
    color: boolean;
    silent: boolean;
    verbose: boolean;
    dir: string;
    instanceIsCLI: boolean;
};
/** App-wide options storage */
export declare let appOptions: {
    logLevel: number;
    color: boolean;
    silent: boolean;
    verbose: boolean;
    dir: string;
    instanceIsCLI: boolean;
};
/**
 * Create full options object using user input and assigns it to appOptions
 */
export declare const parseOptions: (options?: Partial<TSPOptions>) => TSPOptions;
export declare const resetOptions: (options?: Partial<TSPOptions>) => TSPOptions;
